Attribute VB_Name = "Declarations"
'=====================================
'SUPER CONSOLE 1.2 BY SUSHANT PANDURANGI
'=====================================
'This is a DOS-like console made in VB. It has some
'of the standard functions of DOS that can be done
'by using VB. It also has additional and more useful
'tools, like the whois & isport commands, etc.
'=====================================
'Please vote if you consider this worth it. Thanks!
'=====================================
'Sushant Pandurangi (sushant@phreaker.net)
'=====================================
'Have a look at http://sushantshome.tripod.com/vb/
'for more files, tutorials, source code, etc.(Please do
'be sure to include the ending / in the web address.)
'=====================================
Option Explicit
'=====================================
Public fMAIN As Form
Public Arguments() As String
Public Const HelpLine = vbNewLine & "Welcome to SuperConsole. The following is a list of standard commands:" & vbNewLine & vbNewLine & "CLS     DEL    COPY     MOVE     LIST     CD     MD     RD     DIR     NAME     !     ?     PING     WHOIS     IP     HOST     PORT     SCRN     LOAD     HELP     PAUSE     ECHO" & vbNewLine & vbNewLine & "Also, you can enter the filename or pathname of an executable file and run it from within the console. You can specify other (non-executable) files with their extensions and open them in their associated program." & vbNewLine & vbNewLine
Public ColourScheme As Integer
Public WhoIsData As String, WhoIsHost As String
Public PingStat As Long
Dim FileDate As String
Public Const NbSp = " "
Public Const Comma = ","
Public INIFile   As String
Public FWFont As String, VWFont As String
Public Cursor As String
Public PauseMode As Boolean
Public Data As String, Prompt As String
Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Public Declare Function MoveFile Lib "kernel32" Alias "MoveFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String) As Long
Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function ShowCaret Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function HideCaret Lib "user32" (ByVal hwnd As Long) As Long
Dim pos As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Const WM_PASTE = &H302
Public Const WM_CUT = &H300
Public Const WM_COPY = &H301

Sub Parse(CommandLine As String)
On Error GoTo handler 'see what happens
Dim InStrPos As Long, Result As Long, CMD As String, ARGS As String
InStrPos = InStr(1, CommandLine, NbSp) 'find where first space is
If InStrPos = 0 Then CMD = CommandLine Else CMD = Left(CommandLine, InStrPos)
'in case there is no space, CMD that is the command part without the arguments is
'the same as the entire command else we separate the part after the first space.
CMD = Trim(CMD) 'remove spaces
If CMD = "" Then 'nothing is given
fMAIN.RTF1.Text = fMAIN.RTF1.Text & Prompt & Cursor
Exit Sub 'nothing to do now
End If
'the below line gets the arguments part.
ARGS = Right(CommandLine, Len(CommandLine) - Len(CMD))
'Based on the command, this will process the input.
'On error it is set up to go to either label invalid or
'noargs which is appropriate according to the error.
SplitStr ARGS, Arguments(), Comma
'ABOVE:SplitStr is an alternative to the VB6 split function.
'It will split the arguments given for specific commands.
Select Case LCase(CMD)
Case "cls"
    'clear window
    ClearWindow
Case "echo"
    'echo
    Notify ARGS & vbNewLine & Prompt & Cursor
Case "pause"
PauseMode = True
Notify "Press any key to continue..."
Case "port"
    'find if port is active
    IsPort CLng(Arguments(1)), Arguments(0)
Case "ip"
    'find ip address
    Dim IPS
    IPS = GetIPAddress(Arguments(0))
        If IPS = "" Then
            Notify "Could not get IP address." & vbNewLine & Prompt & Cursor
        Else
            Notify IPS & vbNewLine & Prompt & Cursor
        End If
Case "host"
    'find hostname
    Dim HS
    HS = GetHostFromIP(Arguments(0))
        If HS = "" Then
            Notify "Could not get Hostname." & vbNewLine & Prompt & Cursor
        Else
            Notify HS & vbNewLine & Prompt & Cursor
        End If
Case "ping"
    'ping
    If Arguments(0) = "" Then Arguments(0) = GetIPAddress()
    If DoPing(Arguments(0), PingStat) = True Then
        Notify "Pinged " & Arguments(0) & " in " & PingStat & " MS." & vbNewLine & Prompt & Cursor
    Else
        Notify "Could not ping " & Arguments(0) & "." & vbNewLine & Prompt & Cursor
    End If
Case "load"
    If Right(Arguments(0), 3) = "jpg" Or Right(Arguments(0), 3) = "gif" Or Right(Arguments(0), 3) = "bmp" Then
    fMAIN.PM.Picture = LoadPicture(Arguments(0))
    fMAIN.PM.Visible = True
    fMAIN.RTF1.Visible = False
    fMAIN.RTF1.Text = fMAIN.RTF1.Text & Prompt & Cursor
    fMAIN.Form_Resize
    Else
    Open Arguments(0) For Input As #1
    fMAIN.RTF1.Text = fMAIN.RTF1.Text & vbNewLine & Input(LOF(1), 1) & vbNewLine & Prompt & Cursor
    Close #1
    End If
Case "scrn"
'fullscreen
Dim TEMPTEXT As String
    If TypeOf fMAIN Is Console Then
        fMAIN.Hide
        If Right(fMAIN.RTF1.Text, 1) = "_" Or Right(fMAIN.RTF1.Text, 1) = "|" Then
        TEMPTEXT = Left(fMAIN.RTF1.Text, Len(fMAIN.RTF1.Text) - 1) & Prompt & Cursor
        Else
        TEMPTEXT = fMAIN.RTF1.Text & Prompt & Cursor
        End If
        Set fMAIN = New FullScreen
        fMAIN.RTF1.Text = TEMPTEXT
        fMAIN.Show
    Else
        fMAIN.Hide
        If Right(fMAIN.RTF1.Text, 1) = "_" Or Right(fMAIN.RTF1.Text, 1) = "|" Then
        TEMPTEXT = Left(fMAIN.RTF1.Text, Len(fMAIN.RTF1.Text) - 1) & Prompt & Cursor
        Else
        TEMPTEXT = fMAIN.RTF1.Text & Prompt & Cursor
        End If
        Set fMAIN = New Console
        fMAIN.RTF1.Text = TEMPTEXT
        fMAIN.Show
    End If
Case "!"
    'set options
    fMAIN.SetOptions
    Options.Show vbModal
    fMAIN.RTF1.Text = fMAIN.RTF1.Text & Prompt & Cursor
Case "whois"
    WhoIsInfo Arguments(0)
Case "?"
    Notify HelpLine & Prompt & Cursor
Case "help"
'open helpfile
    Open App.Path & "\help.txt" For Input As #1
    fMAIN.RTF1.Text = fMAIN.RTF1.Text & vbNewLine & Input(LOF(1), 1) & vbNewLine & Prompt & Cursor
    Close #1
Case "move"
    'command to move file
    fMAIN.FL.Pattern = Arguments(0)
    If Right(Arguments(1), 1) <> "\" Then Arguments(1) = Arguments(1) & "\"
        For pos = 0 To fMAIN.FL.ListCount - 1
            Result = MoveFile(fMAIN.FL.List(pos), Arguments(1) & fMAIN.FL.List(pos))
            If Result = 1 Then Notify fMAIN.FL.List(pos) & " moved." & vbNewLine Else Notify "Error moving " & fMAIN.FL.List(pos) & "." & vbNewLine
        Next pos
    Notify Prompt & Cursor
    fMAIN.FL.Pattern = "*.*"
Case "copy"
    'command to copy file
    Dim sEXIsts As Long
    fMAIN.FL.Pattern = Arguments(0)
    If Right(Arguments(1), 1) <> "\" Then Arguments(1) = Arguments(1) & "\"
        For pos = 0 To fMAIN.FL.ListCount - 1
            Result = CopyFile(fMAIN.FL.List(pos), Arguments(1) & fMAIN.FL.List(pos), sEXIsts)
            MsgBox sEXIsts
            If Result = 1 Then Notify fMAIN.FL.List(pos) & " copied." & vbNewLine Else Notify "Error copying " & fMAIN.FL.List(pos) & "." & vbNewLine
        Next pos
    Notify Prompt & Cursor
    fMAIN.FL.Pattern = "*.*"
Case "del"
    'command to delete file
    fMAIN.FL.Pattern = Arguments(0)
        For pos = 0 To fMAIN.FL.ListCount - 1
            Result = DeleteFile(fMAIN.FL.List(pos))
            If Result = 1 Then Notify fMAIN.FL.List(pos) & " deleted." & vbNewLine Else Notify "Error deleting " & fMAIN.FL.List(pos) & "." & vbNewLine
        Next pos
    fMAIN.FL.Pattern = "*.*"
    Notify Prompt & Cursor
Case "cd"
    'command to change dir
        If Arguments(0) = "$" Then Arguments(0) = App.Path
        ChDir Arguments(0)
        Prompt = CurDir() & ">"
        fMAIN.RTF1.Text = fMAIN.RTF1.Text & Prompt & Cursor
        fMAIN.FL.Path = CurDir()
Case "rd"
    'command to remove dir
        If Arguments(0) = "$" Then Arguments(0) = App.Path
        RmDir Arguments(0)
        Notify "Folder [" & Arguments(0) & "] removed."
Case "dir"
    'current dir
        Notify "Current directory is " & CurDir & vbNewLine & Prompt & Cursor
Case "md"
    'command to create dir
        If Arguments(0) = "$" Then Arguments(0) = App.Path
        MTpp m #1
nt As String
Public Cn Arg d"
 HLe "md"
    'cf,' ECHry rg d"
     tPrivateProfileStringA" (ByVal lpApp"*.pApp"*.pApp"*.pApp"*.pApp"*.pApp"*.pApp"*.pApp"*.pApp"*.pAppent.Textompt & CursoApp"*uos))
  .Hide
    *.pApp"*.pApp"*.pAppent.Te  'cThen ACser End If
nt.Te .Hisim IPuos))
  .os))
as